package de.fhdo.gerding.wifibuttonled;

import java.net.InetAddress;
import java.net.UnknownHostException;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

public class WifiButtonLed extends Activity 
{
	private WifiManager wifi;
	private ArduinoCommManager commMan;
	private TextView textView_Status;
	private TextView editText_Ip;
	private TextView editText_Port;
	@Override
    public void onCreate(Bundle savedInstanceState) 
    {
		Log.i("WifiButtonLed","onCreate");
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_wifi_button_led);
        //Fixieren auf Portrt-Orientierung (kein automatisches Bildschirmdrehen)
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        textView_Status = (TextView) findViewById(R.id.textview_Status);
        editText_Ip = (EditText) findViewById(R.id.editText_IP);
        editText_Port = (EditText) findViewById(R.id.editText_PORT);
        
        wifi = (WifiManager) getSystemService(Context.WIFI_SERVICE);
        commMan = new ArduinoCommManager();
        WifiInfo info = wifi.getConnectionInfo();
        //Ausgeben simpler WLAN-Verbindungseigenschaften
		textView_Status.setText("WiFi Status: " + info.toString());
		
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) 
    {
    	Log.i("WifiButtonLed","onCreateOptionsMenu");
        getMenuInflater().inflate(R.menu.activity_wifi_button_led, menu);
        return true;
    }
    public void onToggleClicked(View view) 
    {
    	Log.i("WifiButtonLed","onToggleClicked");
    	InetAddress ip;
    	int port;
    	int pin = 11;
    	//Ip und Port bestimmen.
    	try
    	{
    		Log.i("WifiButtonLed","onToggleClicked try 1 IP holen");
    		//IP aus dem Textfeld holen(falls unverndert standard ip)
    		if(editText_Ip.getText().toString().equals(""))
    		{
    			Log.i("WifiButtonLed","onToggleClicked try 1 IP holen if");
    			// Get by IP as host name
    			ip = InetAddress.getByName("192.168.2.1");
    		}
    		else
    		{
    			Log.i("WifiButtonLed","onToggleClicked try 1 IP holen else");
    			ip = InetAddress.getByName(editText_Ip.getText().toString());
    		}
    	}catch (Exception ex)
    	{
    		Log.i("WifiButtonLed","onToggleClicked try 1 IP holen catch");
			Toast.makeText(this, "IP nicht erreichbar",
					Toast.LENGTH_LONG).show();
			return;
		}
    	//Port aus dem Textfeld holen(falls unverndert standard port)
    	if(editText_Port.getText().toString().equals(""))
    	{
    		Log.i("WifiButtonLed","onToggleClicked Port holen if");
    		port = 80;
    	}
    	else
    	{
    		Log.i("WifiButtonLed","onToggleClicked  Port holen else");
    		port = Integer.valueOf(editText_Port.getText().toString());
    	}
    	//Button aktiv?
        boolean on = ((ToggleButton) view).isChecked();
        
        try
    	{
        	Log.i("WifiButtonLed","onToggleClicked try 2 try");
        	if (on) 
        	{
        		Log.i("WifiButtonLed","onToggleClicked try 2 Button aktiv if");
        		//	Button ist aktiv
        		//	LED AN
        		commMan.sendDigitalCommand(pin, true, ip, port);
        	}else 
        	{
        		Log.i("WifiButtonLed","onToggleClicked try 2 Button inaktiv else");
        		//Button ist inaktiv
        		//LED AUS
        		commMan.sendDigitalCommand(pin, false, ip, port);
        	}
    	}catch (Exception ex)
    	{
    		Log.i("WifiButtonLed","onToggleClicked try 2 catch");
    		//System.out.println(ex.getMessage());
    		Toast.makeText(this, ex.getMessage(), Toast.LENGTH_LONG).show();
    	}
    }
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		Log.i("WifiButtonLed","onKeyDown");
        if (keyCode == KeyEvent.KEYCODE_BACK) 
        {
        	this.finish();
        }
        return super.onKeyDown(keyCode, event);
    }
}
